[原创]POJ 3252 Round Numbers [数位DP]【动态规划】
[原创]POJ 3252 Round Numbers [数位DP]【动态规划】
2016-08-25 23:11:27 Tabris_ 阅读数:323
博客爬取于2020-06-14 22:43:39
以下为正文
版权声明:本文为Tabris原创文章,未经博主允许不得私自转载。
https://blog.csdn.net/qq_33184171/article/details/52319408
题目连接:http://poj.org/problem?id=3252
-----------------------------.
Round Numbers
Time Limit: 2000MS Memory Limit: 65536K
Total Submissions: 12190 Accepted: 4629
Description
The cows, as you know, have no fingers or thumbs and thus are unable to play Scissors, Paper, Stone’ (also known as ‘Rock, Paper, Scissors’, ‘Ro, Sham, Bo’, and a host of other names) in order to make arbitrary decisions such as who gets to be milked first. They can’t even flip a coin because it’s so hard to toss using hooves.
They have thus resorted to “round number” matching. The first cow picks an integer less than two billion. The second cow does the same. If the numbers are both “round numbers”, the first cow wins,
otherwise the second cow wins.
A positive integer N is said to be a “round number” if the binary representation of N has as many or more zeroes than it has ones. For example, the integer 9, when written in binary form, is 1001. 1001 has two zeroes and two ones; thus, 9 is a round number. The integer 26 is 11010 in binary; since it has two zeroes and three ones, it is not a round number.
Obviously, it takes cows a while to convert numbers to binary, so the winner takes a while to determine. Bessie wants to cheat and thinks she can do that if she knows how many “round numbers” are in a given range.
Help her by writing a program that tells how many round numbers appear in the inclusive range given by the input (1 ≤ Start < Finish ≤ 2,000,000,000).
Input
Line 1: Two space-separated integers, respectively Start and Finish.
Output
Line 1: A single integer that is the count of round numbers in the inclusive range Start…Finish
Sample Input
2 12
Sample Output
6
Source
USACO 2006 November Silver
---------------------------.
题目大意 :
就是计算出区间[first,end]之间 二进制下 不含前导0且0的个数比1的个数多少的数的个数
解题思路:
跟人用的数位DP
后来看网上的题解 有用组合数学 解决的 有兴趣的话 可以去看一下 .
数位DP 就没什么好解释的了 分别记录下0和1的个数 然后DP就行了
DP[当前位数][1的个数][0的个数];;;
dfs(当前位数,被没被放过,1的个数,0的个数,数字限制);
但是在DP中鄙人出现了一个大的BUG 那就是如下的代码(问题已解决)
1 | /*在for循环的时候 鄙人最开始使用下面注释掉的方式写的代码 |
上面的问题 主要是tji,tou值的初始化有问题
改成这样就行了
1 | { |
我那样的话值会错误的非常离谱因为判断的时候判断的就是ji,ou加不加1 的问题 而我渣忽略了没有操作的情况 导致值变成了0 最终造成结果错误 …
/真TMZZ/
附本题代码
-------------------------------.
1 | //#include <bits/stdc++.h> |